<template>
  <div class="mt-2">
    <v-card style="max-width: 80%;" class="mx-auto pa-3">
      <p class="app-title">Form Edit</p>
      <ValidationObserver ref="form" v-slot="{ handleSubmit }">
        <v-form @submit.prevent="handleSubmit(onSubmit)">
          <ValidationProvider v-slot="{ errors }" name="name" rules="required">
            <v-text-field
              label="name"
              placeholder="dinda hauw"
              :error-messages="errors"
              color="#f26525"
              v-model="name"
            ></v-text-field>
          </ValidationProvider>
          <ValidationProvider v-slot="{ errors }" name="email" rules="required">
            <v-text-field
              label="Email"
              placeholder="dinda@gmail.com"
              :error-messages="errors"
              color="#f26525"
              v-model="email"
            ></v-text-field>
          </ValidationProvider>
          <ValidationProvider v-slot="{ error }" name="Amount" rules="">
            <v-select
              :items="listGrade"
              filled
              item-text="grade_name"
              return-object
              :error-messages="error"
              label="Amount"
              v-model="amount"
            ></v-select>
          </ValidationProvider>
          <v-btn
            :loading="loading"
            outlined
            color="#f26525"
            type="submit"
            class="my-10"
            ><span class="">Submit</span></v-btn
          >
        </v-form>
      </ValidationObserver>
    </v-card>
  </div>
</template>
<script>
import { createNamespacedHelpers } from "vuex";
const data = createNamespacedHelpers("data");
const master = createNamespacedHelpers("master");
export default {
  name: "loginForm",
  props: {},
  data() {
    return {
      name: null,
      email: null,
      amount: null,
      loading: false,
      items: [
        {
          id: 1,
          name: "amount 1"
        },
        {
          id: 2,
          name: "amount 2"
        },
        {
          id: 3,
          name: "amount 3"
        }
      ]
    };
  },
  mounted() {
    this.$store.commit("data/SET_IDDATA", this.$route.params.id);
    this.$store.dispatch("data/getDataById");
    this.$store.dispatch("master/getGrade");
  },
  computed: {
    ...data.mapState(["resDataById"]),
    ...master.mapState(["listGrade"])
  },
  watch: {
    resDataById(newval) {
      this.name = newval[0].name;
      this.email = newval[0].email;
      // this.amount = newval[0].amount;
      this.listGrade.forEach(item => {
        if (parseInt(newval[0].amount) === item.id) {
          this.amount = item;
        }
      });
    }
  },
  methods: {
    onSubmit() {
      this.loading = true;
      this.formInput = {
        name: this.name,
        email: this.email,
        amount: this.amount.id
      };
      this.$store.commit("data/SET_TEMPDATA", this.formInput);
      this.$store
        .dispatch("data/editData")
        .then(response => {
          const res = response.data;
          if (res.status) {
            this.loading = false;
            this.$swal
              .fire("Success!", res.status.message, "success")
              .then(result => {
                if (result.isConfirmed) {
                  this.$router.push("/master-data");
                }
              });
          } else {
            this.loading = false;
            this.$swal("Success!!!");
          }
        })
        .catch(error => {
          const message = error.response.status.message;
          this.errorMessage = message;
          this.$swal.fire("Error!!", this.errorMessage, "error");
          this.loading = false;
        });
    }
  }
};
</script>
